﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;

namespace ProRestaurant.Models.Restaurants
{
    public class MenuItem : BaseObject
    {
        [ForeignKey("Restaurant")]
        public int RestaurantId { get; set; }
        public int CategoryId { get; set; }
        public string Image { get; set; }
        public string Name { get; set; }
        public string Description { get; set; }
        public decimal Price { get; set; }
        public bool OverrideOptions { get; set; }

        public virtual Restaurant Restaurant { get; set; }        

        [NotMapped]
        public string Category { get; set; }

        [NotMapped]
        public ICollection<MenuOption> Options { get; set; }
    }
}
