﻿using System.Collections.Generic;

namespace ProRestaurant.Models.Restaurants
{
    public class Restaurant : BaseObject
    {
        public string Name { get; set; }        
        public string Logo { get; set; }        
        public decimal DeliveryFee { get; set; }
        public decimal DeliveryRadius { get; set; }
        public string MethodsOfPayment { get; set; } //Comma separated list - can be displayed as a drop down. 
        public string ShoppingCentre { get; set; }
        public string ShopNumber { get; set; }
        public string GoogleMapUrl { get; set; }
        public decimal Latitude { get; set; }
        public decimal Longitude { get; set; }
        public string StreetNumber { get; set; }
        public string StreetName { get; set; }
        public string Suburb { get; set; }
        public string City { get; set; }
        public string Province { get; set; }
        public string Country { get; set; }
        public string PostalCode { get; set; }
        public string DeliveryTime { get; set; }
        public string Categories { get; set; }

        public ICollection<TradingHours> TradingHours { get; set; }   
        public ICollection<RestaurantUser> Users { get; set; }        
    }
}
