﻿using ProRestaurant.Containers;
using ProRestaurant.Models.Restaurants;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace ProRestaurant.Repository.Restaurants
{
    public interface IRestaurantRepository
    {
        List<Restaurant> GetRestaurants();
        List<RestaurantCard> GetSearch();
        List<TradingHours> GetTradingHours(int restaurantId);
        RestaurantDetails GetRestaurant(Func<Restaurant, bool> where);
        void Insert(Restaurant restaurant);
        void Remove(Restaurant restaurant);
        void Update(RestaurantDetails restaurant);
        void RemoveTradeHours(int id);
        void Save();
    }    
}
