﻿using Microsoft.EntityFrameworkCore;
using ProRestaurant.DBContexts;
using ProRestaurant.Models.Restaurants;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace ProRestaurant.Repository.Restaurants
{
    public class MenuCategoryRepository : IMenuCategoryRepository
    {
        private readonly DBContext dBContext;

        public MenuCategoryRepository(DBContext db)
        {
            dBContext = db;
        }

        public IEnumerable<MenuCategory> GetMenuCategory()
        {
            return dBContext.MenuCategories.ToList();
        }

        public IEnumerable<MenuCategory> GetMenuCategories(Func<MenuCategory, bool> where)
        {
            return dBContext.MenuCategories.Where(where).ToList();
        }

        public MenuCategory GetMenuCategory(Func<MenuCategory, bool> where)
        {
            return dBContext.MenuCategories.Where(where).FirstOrDefault();
        }

        public void Insert(MenuCategory MenuCategory)
        {
            dBContext.Add(MenuCategory);
            Save();
        }

        public void Remove(MenuCategory MenuCategory)
        {
            dBContext.Remove(MenuCategory);
            Save();
        }

        public void Save()
        {
            dBContext.SaveChanges();
        }

        public void Update(MenuCategory MenuCategory)
        {
            dBContext.Entry(MenuCategory).State = EntityState.Modified;
            Save();
        }
    }
}
